macro_file HFM_INST
/****************************************************************************
                            MULTI-EDIT MACRO FILE

Name: Multi-Edit Hypertext file Manager Version 2.04

HFM_INST - Install Hypertext file Manager

********(C) Copyright 1995-1997 by Dmitry A.Steklenev *********************/

// $Log: hfm_inst.s $
// Revision 1.7  1997/10/12 22:05:26  GLASS
// - Fixed minor bug in "Create Index File" module.
//
// Revision 1.6  1997/05/27 15:57:14  GLASS
// - New Version 2.03 (installation changed)
//
// Revision 1.5  1996/05/22 19:39:00  GLASS
// - Fixed very small bug.
//
// Revision 1.4  1996/05/15 19:38:52  GLASS
// - Add "Create Index File" module;
// - Automated exit from ME after installation.
//
// Revision 1.3  1996/01/19 22:12:52  GLASS
// - Changed the block size via HelpCX (new size = 15 Kb)
//
// Revision 1.2  1996/01/09 21:17:46  GLASS
// - Fixed Bugs in keymap installation
//
// Revision 1.1  1996/01/09 20:36:01  GLASS
// Initial revision
//

macro HFM_INST TRANS2 {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_INST
Description: Install Hypertext file Manager.

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  rm( 'HFM_UTIL^HFM_ABOUT' );
  rm( 'HFM_UTIL^HFM_SCAN'  );

  int mepos;
  int curwinid = window_id;
  str pathlst  = global_str("HYPER_DIRS");
  str startup  = me_path + "SRC\\STARTUP.S";

  while(( mepos = xpos( me_path, pathlst, 1 )) != 0 )
  {
    pathlst = str_del( pathlst, mepos, length(me_path));
    pathlst = str_ins( "<ME_PATH>", pathlst, mepos    );
  }

  refresh=false;
  create_window;
  error_level = 0;
  load_file( startup );

  if( error_level)
  {
    delete_window;
    error_level = 0;
    rm( "MEERROR^MESSAGEBOX /T=" + "[HYPERTEXT FILE MANAGER] /B=1" +
                           "/M=Can't find " + startup               );
    goto configure;
  }

  reg_exp_stat = false;

  if( search_fwd( "!HELP_PATH", 0 ))
  {
    del_line;
    home; cr; up; home;
  }
  else
  {
    eof;
    search_bwd( "}", 0 );
    up; eol; cr; cr;
    put_line( "// This is the path to find the help files.");
    eol; cr;
  }
  put_line( "   Set_Global_Str('!HELP_PATH!', '" + pathlst + "');" );
  save_file;

  return_str = me_path + "cmac.exe " + startup + " /P" + me_path + "MAC\\";
  rm( 'MEUTIL1^EXEC /SCREEN=3' );
  delete_window;

  if( exit_code )
  {
    error_level = 0;
    rm( "MEERROR^MESSAGEBOX /T="  + "[HYPERTEXT FILE MANAGER] /B=1" +
                           "/M=Compile error: " + startup           );
  }

configure:

  str key_list[20];
  str key_show[20];
  str key_cntx[20];
  int add_user = 1;
  int menu = menu_create;

  menu_set_item( menu, 1, "Pops up a list of hypertext files:"     , "<ShftF1>", "/QK=1/L=2/W=20/C=1/M=SETUP^DEFINE_KEY ", 8,0,0 );
  menu_set_item( menu, 2, "Shows the hypertext file:         "     , "<F1>"    , "/QK=1/L=3/W=20/C=1/M=SETUP^DEFINE_KEY ", 8,0,0 );
  menu_set_item( menu, 3, "sUpports context sensitive help:  "     , "<CtrlF1>", "/QK=2/L=4/W=20/C=1/M=SETUP^DEFINE_KEY ", 8,0,0 );
  menu_set_item( menu, 4, "Add Hypertext File Manager to User Menu", ""        , "/QK=1/L=6/W=20/C=1"                    ,13,1,0 );

  return_int = menu;
  rm("USERIN^DATA_IN /T=[HYPERTEXT FILE MANAGER KEY ASSIGNMENT]/#=4/HN=1/H=HFM^*" );
  if( return_int )
  {
    key_list = menu_item_str( menu, 1, 2 );
    key_show = menu_item_str( menu, 2, 2 );
    key_cntx = menu_item_str( menu, 3, 2 );
    add_user = menu_item_int( menu, 4, 2 );
    menu_delete(menu);
  }
  else
  {
    menu_delete(menu);
    goto exit;
  }

  refresh = 0;
  return_str = parse_str( 'FN=', global_str("@KEYMAP_NAME@"));

  if( global_str('@DB_EXTENSION') == '')
      return_str = return_str + '.DB';
  else
      return_str = return_str + '.' + global_str('@DB_EXTENSION');

  rm( 'MAKEUSERPATH /DF=1' );

  if( switch_file( return_str ) == 0 )
  {
    create_window;
    error_level = 0;
    load_file( return_str );

    if( error_level) {
      delete_window;
      error_level = 0;
      rm( "MEERROR^MESSAGEBOX /T="  + "[HYPERTEXT FILE MANAGER]" +
                             "/B=1" +
                             "/M=Can't find " + return_str       );
      goto exit;
    }
  }
  window_attr = $81;

  reg_exp_stat = true;
  tof; if( search_fwd( "@@=-+ MULTI-EDIT HYPERTEXT FILE", 0 )) del_line;
  tof; if( search_fwd( "Pops up a list of hypertext files", 0 )) del_line;
  tof; if( search_fwd( "Shows the hypertext file"         , 0 )) del_line;
  tof; if( search_fwd( "Context sensitive help"           , 0 )) del_line;

  if( length( remove_space( key_list )) != 0 )
  {
    tof; while( search_fwd( "K[12]=" + key_list, 0 ))
                del_chars( length(key_list) + 4 );
  }
  if( length( remove_space( key_show )) != 0 )
  {
    tof; while( search_fwd( "K[12]=" + key_show, 0 ))
                del_chars( length(key_show) + 4 );
  }
  if( length( remove_space( key_cntx )) != 0 )
  {
    tof; while( search_fwd( "K[12]=" + key_cntx, 0 ))
                del_chars( length(key_cntx) + 4 );
  }

  eof;
  down;
  put_line( "@=------------------- "           +
            "MULTI-EDIT HYPERTEXT FILE MANAGER " +
            "--------------------"               );
  down;

  put_line( "MC=HFM_LIST"                              +
            "MF=HFM_UTIL"                              +
            "DESCR=Pops up a list of hypertext files"  +
            "K1=" + key_list                           +
            "FKL=HlpLst"                               +
            "MID=!HFM_LST"                             +
            "MODE=1"                                   );
  down;

  put_line( "MC=HFM_SHOW"                              +
            "MF=HFM_UTIL"                              +
            "DESCR=Shows the hypertext file"           +
            "K1=" + key_show                           +
            "FKL=HlpShw"                               +
            "MID=!HFM_SHW"                             +
            "MODE=1"                                   );
  down;

  put_line( "MC=HFM_CNTX"                              +
            "MF=HFM_UTIL"                              +
            "DESCR=Context sensitive help"             +
            "K1=" + key_cntx                           +
            "FKL=HlpCnt"                               +
            "MID=!HFM_CNT"                             +
            "MODE=1"                                   );
  down;

  set_global_int( "SETUP_CHANGED", global_int("SETUP_CHANGED") | $02 );
  rm( 'SETUP^SETSAVE' );

  if( add_user )
  {
    rm("SETCONFIG /DB=MECONFIG/T=USER.MNU");
    if( !return_int )
    {
      rm("MEERROR^MESSAGEBOX /B=2/T=ERROR" +
         "/M=Unable to find User menu in MECONFIG.DB");
      goto exit;
    }
    eol; mark_pos;
    ignore_case = true;
    if( search_fwd( "Hypertext File Manager", 0 ))
    {
      del_line;
      up; eol; cr;
      put_line( "NAME=Hypertext File Manager" +
                "CMD=HFM_UTIL^HFM_MENUTYPE=5CS=0" );
    }
    else
    {
      goto_mark; cr;
      put_line( "NAME=Hypertext File Manager" +
                "CMD=HFM_UTIL^HFM_MENUTYPE=5CS=0" );
      eol;cr;
      put_line( "NAME=...TYPE=6CS=0" );
    }
    if( global_int('~USER_MENU'))
    {
      menu_delete( global_int('~USER_MENU'));
      set_global_int('~USER_MENU', 0 );
    }
  }

exit:

  Make_Message("Hypertext File Manager installation completed.");

  int readstate = read_only;

  create_window;
  error_level = 0;
  load_file( me_path + "\\DOC\\README.HFM" );
  error_level = 0;

  read_only = true;
  rm( "USERIN^EDITWINDOW /X=3/Y=4/W=74/L=15/T=[HYPERTEXT FILE MANAGER V2.04]/A=1");
  read_only = readstate;
  delete_window;

  switch_win_id( curwinid );
  refresh=true;

  rm( "EXIT" );
}
